#

API Docs for: v3.8.1
Show: Inherited Protected Private Deprecated

# DS.JSONSerializer Class

Extends DS.Serializer
Defined in: `addon/serializers/json.js:16`
Module: ember-data

Ember Data 2.0 Serializer:

In Ember Data a Serializer is used to serialize and deserialize records when they are transferred in and out of an external source. This process involves normalizing property names, transforming attribute values and serializing relationships.

By default, Ember Data uses and recommends the `JSONAPISerializer`.

`JSONSerializer` is useful for simpler or legacy backends that may not support the http://jsonapi.org/ spec.

For example, given the following `User` model and JSON payload:

    import DS from 'ember-data';

    export default DS.Model.extend({
      friends: DS.hasMany('user'),
      house: DS.belongsTo('location'),

      name: DS.attr('string')
    });

    {
      id: 1,
      name: 'Sebastian',
      friends: [3, 4],
      links: {
        house: '/houses/lefkada'
      }
    }

`JSONSerializer` will normalize the JSON payload to the JSON API format that the Ember Data store expects.

You can customize how JSONSerializer processes its payload by passing options in the `attrs` hash or by subclassing the `JSONSerializer` and overriding hooks:

- To customize how a single record is normalized, use the `normalize` hook.
- To customize how `JSONSerializer` normalizes the whole server response, use the `normalizeResponse` hook.
- To customize how `JSONSerializer` normalizes a specific response from the server, use one of the many specific `normalizeResponse` hooks.
- To customize how `JSONSerializer` normalizes your id, attributes or relationships, use the `extractId`, `extractAttributes` and `extractRelationships` hooks.

The `JSONSerializer` normalization process follows these steps:

- `normalizeResponse` - entry method to the serializer.
- `normalizeCreateRecordResponse` - a `normalizeResponse` for a specific operation is called.
- `normalizeSingleResponse`|`normalizeArrayResponse` - for methods like `createRecord` we expect a single record back, while for methods like `findAll` we expect multiple records back.
- `normalize` - `normalizeArray` iterates and calls `normalize` for each of its records while `normalizeSingle` calls it once. This is the method you most likely want to subclass.
- `extractId` | `extractAttributes` | `extractRelationships` - `normalize` delegates to these methods to turn the record payload into the JSON API format.

- Index
- Methods
- Properties

## Item Index

### Methods

- _canSerialize
- _getMappedKey
- _mustSerialize
- _normalizeResponse
- applyTransforms
- extractAttributes
- extractErrors
- extractId
- extractMeta
- extractPolymorphicRelationship
- extractRelationship
- extractRelationships
- keyForAttribute
- keyForLink
- keyForRelationship
- modelNameFromPayloadKey
- normalize
- normalizeArrayResponse
- normalizeCreateRecordResponse
- normalizeDeleteRecordResponse
- normalizeFindAllResponse
- normalizeFindBelongsToResponse
- normalizeFindHasManyResponse
- normalizeFindManyResponse
- normalizeFindRecordResponse
- normalizeQueryRecordResponse
- normalizeQueryResponse
- normalizeRelationships
- normalizeResponse
- normalizeSaveResponse
- normalizeSingleResponse
- normalizeUpdateRecordResponse
- normalizeUsingDeclaredMapping
- serialize
- serializeAttribute
- serializeBelongsTo
- serializeHasMany
- serializeIntoHash
- serializePolymorphicType
- shouldSerializeHasMany
- transformFor

### Properties

- attrs
- primaryKey
- store

## Methods

### `_canSerialize`

(

- `key`

)
Boolean private

Defined in `addon/serializers/json.js:829`

Check attrs.key.serialize property to inform if the `key` can be serialized

#### Parameters:

- `key` String

#### Returns:

Boolean:

true if the key can be serialized

### `_getMappedKey`

(

- `key`

)
String private

Defined in `addon/serializers/json.js:790`

Looks up the property key that was set by the custom `attr` mapping passed to the serializer.

#### Parameters:

- `key` String

#### Returns:

String:

key

### `_mustSerialize`

(

- `key`

)
Boolean private

Defined in `addon/serializers/json.js:844`

When attrs.key.serialize is set to true then it takes priority over the other checks and the related attribute/relationship will be serialized

#### Parameters:

- `key` String

#### Returns:

Boolean:

true if the key must be serialized

### `_normalizeResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`
- `isSingle`

)
Object private

Defined in `addon/serializers/json.js:446`

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String
- `isSingle` Boolean

#### Returns:

Object:

JSON-API Document

### `applyTransforms`

(

- `typeClass`
- `data`

)
Object private

Defined in `addon/serializers/json.js:175`

Given a subclass of `DS.Model` and a JSON object this method will iterate through each attribute of the `DS.Model` and invoke the `DS.Transform#deserialize` method on the matching property of the JSON object. This method is typically called after the serializer's `normalize` method.

#### Parameters:

- `typeClass` DS.Model
- `data` Object

  The data to transform

#### Returns:

Object:

data The transformed data object

### `extractAttributes`

(

- `modelClass`
- `resourceHash`

)
Object

Defined in `addon/serializers/json.js:572`

Returns the resource's attributes formatted as a JSON-API "attributes object".

http://jsonapi.org/format/#document-resource-object-attributes

#### Parameters:

- `modelClass` Object
- `resourceHash` Object

#### Returns:

Object:

### `extractErrors`

(

- `store`
- `typeClass`
- `payload`
- `id`

)
Object

Defined in `addon/serializers/json.js:1306`

`extractErrors` is used to extract model errors when a call to `DS.Model#save` fails with an `InvalidError`. By default Ember Data expects error information to be located on the `errors` property of the payload object.

This serializer expects this `errors` object to be an Array similar to the following, compliant with the https://jsonapi.org/format/#errors specification:

    {
      "errors": [
        {
          "detail": "This username is already taken!",
          "source": {
            "pointer": "data/attributes/username"
          }
        }, {
          "detail": "Doesn't look like a valid email.",
          "source": {
            "pointer": "data/attributes/email"
          }
        }
      ]
    }

The key `detail` provides a textual description of the problem. Alternatively, the key `title` can be used for the same purpose.

The nested keys `source.pointer` detail which specific element of the request data was invalid.

Note that JSON-API also allows for object-level errors to be placed in an object with pointer `data`, signifying that the problem cannot be traced to a specific attribute:

    {
      "errors": [
        {
          "detail": "Some generic non property error message",
          "source": {
            "pointer": "data"
          }
        }
      ]
    }

When turn into a `DS.Errors` object, you can read these errors through the property `base`:

    {{#each model.errors.base as |error|}}
      <div class="error">
        {{error.message}}
      </div>
    {{/each}}

Example of alternative implementation, overriding the default behavior to deal with a different format of errors:

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      extractErrors(store, typeClass, payload, id) {
        if (payload && typeof payload === 'object' && payload._problems) {
          payload = payload._problems;
          this.normalizeErrors(typeClass, payload);
        }
        return payload;
      }
    });

#### Parameters:

- `store` DS.Store
- `typeClass` DS.Model
- `payload` Object
- `id` (String | Number)

#### Returns:

Object:

json The deserialized errors

### `extractId`

(

- `modelClass`
- `resourceHash`

)
String

Defined in `addon/serializers/json.js:558`

Returns the resource's ID.

#### Parameters:

- `modelClass` Object
- `resourceHash` Object

#### Returns:

String:

### `extractMeta`

(

- `store`
- `modelClass`
- `payload`

)

Defined in `addon/serializers/json.js:1272`

`extractMeta` is used to deserialize any meta information in the adapter payload. By default Ember Data expects meta information to be located on the `meta` property of the payload object.

Example

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      extractMeta(store, typeClass, payload) {
        if (payload && payload.hasOwnProperty('_pagination')) {
          let meta = payload._pagination;
          delete payload._pagination;
          return meta;
        }
      }
    });

#### Parameters:

- `store` DS.Store
- `modelClass` DS.Model
- `payload` Object

### `extractPolymorphicRelationship`

(

- `relationshipModelName`
- `relationshipHash`
- `relationshipOptions`

)
Object

Defined in `addon/serializers/json.js:630`

Returns a polymorphic relationship formatted as a JSON-API "relationship object".

http://jsonapi.org/format/#document-resource-object-relationships

`relationshipOptions` is a hash which contains more information about the polymorphic relationship which should be extracted:

- `resourceHash` complete hash of the resource the relationship should be extracted from
- `relationshipKey` key under which the value for the relationship is extracted from the resourceHash
- `relationshipMeta` meta information about the relationship

#### Parameters:

- `relationshipModelName` Object
- `relationshipHash` Object
- `relationshipOptions` Object

#### Returns:

Object:

### `extractRelationship`

(

- `relationshipModelName`
- `relationshipHash`

)
Object

Defined in `addon/serializers/json.js:596`

Returns a relationship formatted as a JSON-API "relationship object".

http://jsonapi.org/format/#document-resource-object-relationships

#### Parameters:

- `relationshipModelName` Object
- `relationshipHash` Object

#### Returns:

Object:

### `extractRelationships`

(

- `modelClass`
- `resourceHash`

)
Object

Defined in `addon/serializers/json.js:653`

Returns the resource's relationships formatted as a JSON-API "relationships object".

http://jsonapi.org/format/#document-resource-object-relationships

#### Parameters:

- `modelClass` Object
- `resourceHash` Object

#### Returns:

Object:

### `keyForAttribute`

(

- `key`
- `method`

)
String

Defined in `addon/serializers/json.js:1417`

`keyForAttribute` can be used to define rules for how to convert an attribute name in your model to a key in your JSON.

Example

    import DS from 'ember-data';
    import { underscore } from '@ember/string';

    export default DS.RESTSerializer.extend({
      keyForAttribute(attr, method) {
        return underscore(attr).toUpperCase();
      }
    });

#### Parameters:

- `key` String
- `method` String

#### Returns:

String:

normalized key

### `keyForLink`

(

- `key`
- `kind`

)
String

Defined in `addon/serializers/json.js:1471`

`keyForLink` can be used to define a custom key when deserializing link properties.

#### Parameters:

- `key` String
- `kind` String

  `belongsTo` or `hasMany`

#### Returns:

String:

normalized key

### `keyForRelationship`

(

- `key`
- `typeClass`
- `method`

)
String

Defined in `addon/serializers/json.js:1443`

`keyForRelationship` can be used to define a custom key when serializing and deserializing relationship properties. By default `JSONSerializer` does not provide an implementation of this method.

Example

    import DS from 'ember-data';
    import { underscore } from '@ember/string';

    export default DS.JSONSerializer.extend({
      keyForRelationship(key, relationship, method) {
        return rel_${underscore(key)};
      }
    });

#### Parameters:

- `key` String
- `typeClass` String
- `method` String

#### Returns:

String:

normalized key

### `modelNameFromPayloadKey`

(

- `key`

)
String

Defined in `addon/serializers/json.js:724`

#### Parameters:

- `key` String

#### Returns:

String:

the model's modelName

### `normalize`

(

- `typeClass`
- `hash`

)
Object

Inherited from DS.Serializer but overwritten in `addon/serializers/json.js:495`

Normalizes a part of the JSON payload returned by the server. You should override this method, munge the hash and call super if you have generic normalization to do.

It takes the type of the record that is being normalized (as a DS.Model class), the property where the hash was originally found, and the hash to normalize.

You can use this method, for example, to normalize underscored keys to camelized or other general-purpose normalizations.

Example

    import DS from 'ember-data';
    import { underscore } from '@ember/string';
    import { get } from '@ember/object';

    export default DS.JSONSerializer.extend({
      normalize(typeClass, hash) {
        var fields = get(typeClass, 'fields');

        fields.forEach(function(field) {
          var payloadField = underscore(field);
          if (field === payloadField) { return; }

          hash[field] = hash[payloadField];
          delete hash[payloadField];
        });

        return this._super.apply(this, arguments);
      }
    });

#### Parameters:

- `typeClass` DS.Model
- `hash` Object

#### Returns:

Object:

### `normalizeArrayResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Defined in `addon/serializers/json.js:432`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeCreateRecordResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Defined in `addon/serializers/json.js:362`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeDeleteRecordResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Defined in `addon/serializers/json.js:376`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeFindAllResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Defined in `addon/serializers/json.js:292`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeFindBelongsToResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Defined in `addon/serializers/json.js:306`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeFindHasManyResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Defined in `addon/serializers/json.js:320`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeFindManyResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Defined in `addon/serializers/json.js:334`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeFindRecordResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Defined in `addon/serializers/json.js:264`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeQueryRecordResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Defined in `addon/serializers/json.js:278`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeQueryResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Defined in `addon/serializers/json.js:348`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeRelationships`

() private

Defined in `addon/serializers/json.js:734`

### `normalizeResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Inherited from DS.Serializer but overwritten in `addon/serializers/json.js:204`

Available since 1.13.0

The `normalizeResponse` method is used to normalize a payload from the server to a JSON-API Document.

http://jsonapi.org/format/#document-structure

This method delegates to a more specific normalize method based on the `requestType`.

To override this method with a custom one, make sure to call `return this._super(store, primaryModelClass, payload, id, requestType)` with your pre-processed data.

Here's an example of using `normalizeResponse` manually:

    socket.on('message', function(message) {
      var data = message.data;
      var modelClass = store.modelFor(data.modelName);
      var serializer = store.serializerFor(data.modelName);
      var normalized = serializer.normalizeSingleResponse(store, modelClass, data, data.id);

      store.push(normalized);
    });

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeSaveResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Defined in `addon/serializers/json.js:404`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeSingleResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Defined in `addon/serializers/json.js:418`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeUpdateRecordResponse`

(

- `store`
- `primaryModelClass`
- `payload`
- `id`
- `requestType`

)
Object

Defined in `addon/serializers/json.js:390`

Available since 1.13.0

#### Parameters:

- `store` DS.Store
- `primaryModelClass` DS.Model
- `payload` Object
- `id` String | Number
- `requestType` String

#### Returns:

Object:

JSON-API Document

### `normalizeUsingDeclaredMapping`

() private

Defined in `addon/serializers/json.js:757`

### `serialize`

(

- `snapshot`
- `options`

)
Object

Inherited from DS.Serializer but overwritten in `addon/serializers/json.js:884`

Called when a record is saved in order to convert the record into JSON.

By default, it creates a JSON object with a key for each attribute and belongsTo relationship.

For example, consider this model:

    import DS from 'ember-data';

    export default DS.Model.extend({
      title: DS.attr(),
      body: DS.attr(),

      author: DS.belongsTo('user')
    });

The default serialization would create a JSON object like:

    {
      "title": "Rails is unagi",
      "body": "Rails? Omakase? O_O",
      "author": 12
    }

By default, attributes are passed through as-is, unless you specified an attribute type (`DS.attr('date')`). If you specify a transform, the JavaScript value will be serialized when inserted into the JSON hash.

By default, belongs-to relationships are converted into IDs when inserted into the JSON hash.

## IDs

`serialize` takes an options hash with a single option: `includeId`. If this option is `true`, `serialize` will, by default include the ID in the JSON object it builds.

The adapter passes in `includeId: true` when serializing a record for `createRecord`, but not for `updateRecord`.

## Customization

Your server may expect a different JSON format than the built-in serialization format.

In that case, you can implement `serialize` yourself and return a JSON hash of your choosing.

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      serialize(snapshot, options) {
        var json = {
          POST_TTL: snapshot.attr('title'),
          POST_BDY: snapshot.attr('body'),
          POST_CMS: snapshot.hasMany('comments', { ids: true })
        };

        if (options.includeId) {
          json.POST_ID_ = snapshot.id;
        }

        return json;
      }
    });

## Customizing an App-Wide Serializer

If you want to define a serializer for your entire application, you'll probably want to use `eachAttribute` and `eachRelationship` on the record.

    import DS from 'ember-data';
    import { singularize } from 'ember-inflector';

    export default DS.JSONSerializer.extend({
      serialize(snapshot, options) {
        var json = {};

        snapshot.eachAttribute(function(name) {
          json[serverAttributeName(name)] = snapshot.attr(name);
        });

        snapshot.eachRelationship(function(name, relationship) {
          if (relationship.kind === 'hasMany') {
            json[serverHasManyName(name)] = snapshot.hasMany(name, { ids: true });
          }
        });

        if (options.includeId) {
          json.ID_ = snapshot.id;
        }

        return json;
      }
    });

    function serverAttributeName(attribute) {
      return attribute.underscore().toUpperCase();
    }

    function serverHasManyName(name) {
      return serverAttributeName(singularize(name)) + "_IDS";
    }

This serializer will generate JSON that looks like this:

    {
      "TITLE": "Rails is omakase",
      "BODY": "Yep. Omakase.",
      "COMMENT_IDS": [ 1, 2, 3 ]
    }

## Tweaking the Default JSON

If you just want to do some small tweaks on the default JSON, you can call super first and make the tweaks on the returned JSON.

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      serialize(snapshot, options) {
        var json = this._super(...arguments);

        json.subject = json.title;
        delete json.title;

        return json;
      }
    });

#### Parameters:

- `snapshot` DS.Snapshot
- `options` Object

#### Returns:

Object:

json

### `serializeAttribute`

(

- `snapshot`
- `json`
- `key`
- `attribute`

)

Defined in `addon/serializers/json.js:1093`

`serializeAttribute` can be used to customize how `DS.attr` properties are serialized

For example if you wanted to ensure all your attributes were always serialized as properties on an `attributes` object you could write:

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      serializeAttribute(snapshot, json, key, attributes) {
        json.attributes = json.attributes || {};
        this._super(snapshot, json.attributes, key, attributes);
      }
    });

#### Parameters:

- `snapshot` DS.Snapshot
- `json` Object
- `key` String
- `attribute` Object

### `serializeBelongsTo`

(

- `snapshot`
- `json`
- `relationship`

)

Defined in `addon/serializers/json.js:1139`

`serializeBelongsTo` can be used to customize how `DS.belongsTo` properties are serialized.

Example

    import DS from 'ember-data';
    import { isNone } from '@ember/utils';

    export default DS.JSONSerializer.extend({
      serializeBelongsTo(snapshot, json, relationship) {
        var key = relationship.key;
        var belongsTo = snapshot.belongsTo(key);

        key = this.keyForRelationship ? this.keyForRelationship(key, "belongsTo", "serialize") : key;

        json[key] = isNone(belongsTo) ? belongsTo : belongsTo.record.toJSON();
      }
    });

#### Parameters:

- `snapshot` DS.Snapshot
- `json` Object
- `relationship` Object

### `serializeHasMany`

(

- `snapshot`
- `json`
- `relationship`

)

Defined in `addon/serializers/json.js:1192`

`serializeHasMany` can be used to customize how `DS.hasMany` properties are serialized.

Example

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      serializeHasMany(snapshot, json, relationship) {
        var key = relationship.key;
        if (key === 'comments') {
          return;
        } else {
          this._super(...arguments);
        }
      }
    });

#### Parameters:

- `snapshot` DS.Snapshot
- `json` Object
- `relationship` Object

### `serializeIntoHash`

(

- `hash`
- `typeClass`
- `snapshot`
- `options`

)

Defined in `addon/serializers/json.js:1061`

You can use this method to customize how a serialized record is added to the complete JSON hash to be sent to the server. By default the JSON Serializer does not namespace the payload and just sends the raw serialized JSON object. If your server expects namespaced keys, you should consider using the RESTSerializer. Otherwise you can override this method to customize how the record is added to the hash. The hash property should be modified by reference.

For example, your server may expect underscored root objects.

    import DS from 'ember-data';
    import { decamelize } from '@ember/string';

    export default DS.RESTSerializer.extend({
      serializeIntoHash(data, type, snapshot, options) {
        var root = decamelize(type.modelName);
        data[root] = this.serialize(snapshot, options);
      }
    });

#### Parameters:

- `hash` Object
- `typeClass` DS.Model
- `snapshot` DS.Snapshot
- `options` Object

### `serializePolymorphicType`

(

- `snapshot`
- `json`
- `relationship`

)

Defined in `addon/serializers/json.js:1237`

You can use this method to customize how polymorphic objects are serialized. Objects are considered to be polymorphic if `{ polymorphic: true }` is pass as the second argument to the `DS.belongsTo` function.

Example

    import DS from 'ember-data';
    import { isNone } from '@ember/utils';

    export default DS.JSONSerializer.extend({
      serializePolymorphicType(snapshot, json, relationship) {
        var key = relationship.key;
        var belongsTo = snapshot.belongsTo(key);

        key = this.keyForAttribute ? this.keyForAttribute(key, 'serialize') : key;

        if (isNone(belongsTo)) {
          json[key + '_type'] = null;
        } else {
          json[key + '_type'] = belongsTo.modelName;
        }
      }
    });

#### Parameters:

- `snapshot` DS.Snapshot
- `json` Object
- `relationship` Object

### `shouldSerializeHasMany`

(

- `snapshot`
- `key`
- `relationshipType`

)
Boolean

Defined in `addon/serializers/json.js:860`

Check if the given hasMany relationship should be serialized

By default only many-to-many and many-to-none relationships are serialized. This could be configured per relationship by Serializer's `attrs` object.

#### Parameters:

- `snapshot` DS.Snapshot
- `key` String
- `relationshipType` String

#### Returns:

Boolean:

true if the hasMany relationship should be serialized

### `transformFor`

(

- `attributeType`
- `skipAssertion`

)
DS.Transform private

Defined in `addon/serializers/json.js:1486`

#### Parameters:

- `attributeType` String
- `skipAssertion` Boolean

#### Returns:

DS.Transform:

transform

## Properties

### `attrs`

Object

Defined in `addon/serializers/json.js:107`

The `attrs` object can be used to declare a simple mapping between property names on `DS.Model` records and payload keys in the serialized JSON object representing the record. An object with the property `key` can also be used to designate the attribute's key on the response payload.

Example

    import DS from 'ember-data';

    export default DS.Model.extend({
      firstName: DS.attr('string'),
      lastName: DS.attr('string'),
      occupation: DS.attr('string'),
      admin: DS.attr('boolean')
    });

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      attrs: {
        admin: 'is_admin',
        occupation: { key: 'career' }
      }
    });

You can also remove attributes and relationships by setting the `serialize` key to `false` in your mapping object.

Example

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      attrs: {
        admin: { serialize: false },
        occupation: { key: 'career' }
      }
    });

When serialized:

    {
      "firstName": "Harry",
      "lastName": "Houdini",
      "career": "magician"
    }

Note that the `admin` is now not included in the payload.

Setting `serialize` to `true` enforces serialization for hasMany relationships even if it's neither a many-to-many nor many-to-none relationship.

### `primaryKey`

String

Defined in `addon/serializers/json.js:83`

The `primaryKey` is used when serializing and deserializing data. Ember Data always uses the `id` property to store the id of the record. The external source may not always follow this convention. In these cases it is useful to override the `primaryKey` property to match the `primaryKey` of your external store.

Example

    import DS from 'ember-data';

    export default DS.JSONSerializer.extend({
      primaryKey: '_id'
    });

Default: 'id'

### `store`

DS.Store public

Inherited from DS.Serializer: `addon/serializer.js:28`

The `store` property is the application's `store` that contains all records. It can be used to look up serializers for other model types that may be nested inside the payload response. Example: ```js Serializer.extend({ extractRelationship(relationshipModelName, relationshipHash) { var modelClass = this.store.modelFor(relationshipModelName); var relationshipSerializer = this.store.serializerFor(relationshipModelName); return relationshipSerializer.normalize(modelClass, relationshipHash); } }); ```